#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <ogc/ipc.h>
#include <ogc/ios.h>
#include "network.h"

static void *xfb = NULL;
static GXRModeObj *rmode;
char message[256];
unsigned short port = 9001;
u32 ip;
u8 *splitip = (u8 *)&ip;

void Reboot()
{
	// Thanks to hell_hibou
	int fd = IOS_Open("/dev/stm/immediate", 0);
	IOS_Ioctl(fd, 0x2001, NULL, 0, NULL, 0);
	IOS_Close(fd);
}

static inline bool waitfor(u32 button)
{
	while(1)
	{
		PAD_ScanPads();
		if(PAD_ButtonsHeld(0)&button)
			return 1;
		VIDEO_WaitVSync();
	}
}

void MAIN_Init()
{

	VIDEO_Init();
	PAD_Init();

	switch(VIDEO_GetCurrentTvMode())
	{
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	VIDEO_ClearFrameBuffer (rmode,xfb,COLOR_BLACK);
}

int main(int argc, char **argv)
{
	MAIN_Init();

	error:
	
	printf("Starting Net_Init()...\n");

	int Connect = net_init();
	if(Connect != 0)
	{
		printf("Net_Init() failed.\n");
		printf("Press A to retry.\n");
		waitfor(PAD_BUTTON_A);
		goto error;
	}

	printf("Net_Init() successful.\n\n");

	printf("Net_Socket Initializing.\n");
	s32 netSocket = net_socket(AF_INET, SOCK_STREAM, 0);

	if(netSocket == INVALID_SOCKET)
	{
		printf("Net_Socket Initialization failed.\n");
		printf("Press A to retry.\n");
		waitfor(PAD_BUTTON_A);
		goto error;
	}

	printf("Net_Socket Initialized.\n\n");

	printf("Establishing server on port %d.\n",port);
	sockaddr_in sin;
	sin.sin_port=htons(port);
	sin.sin_addr.s_addr=INADDR_ANY;
	sin.sin_family=AF_INET;

	if(net_bind(netSocket,(sockaddr*)&sin, sizeof(sin)) == SOCKET_ERROR)
	{
		printf("Failed to bind.\n");
		printf("Press A to retry.\n");
		waitfor(PAD_BUTTON_A);
		goto error;
	}

	printf("Server established!\n");

	ip = net_gethostip();
	printf("You Wii's ip address is %d.%d.%d.%d\n", splitip[0], splitip[1], splitip[2], splitip[3]);
	printf("Waiting for client to connect...\n");

	while (net_listen(netSocket, 1) == SOCKET_ERROR);

	int client;
	u32 len = sizeof(sin);
	client=net_accept(netSocket, (sockaddr*)&sin, &len);
	printf("Connection established from  %d.%d.%d.%d\n\n",
	(sin.sin_addr.s_addr >> 24) & 0xFF,
	(sin.sin_addr.s_addr >> 16) & 0xFF,
	(sin.sin_addr.s_addr >> 8) & 0xFF,
	(sin.sin_addr.s_addr) & 0xFF);
	
	while(1)
	{
		net_recv(client, message, sizeof(message), 0);
		printf("PC: %s \n",message);
		if(message[0] == 'e' && message[1] == 'x' && message[2] == 'i' && message[3] == 't' && message[4] == NULL)
		{
			net_close(netSocket);
			goto end;
		}
	}

	end:
	VIDEO_ClearFrameBuffer (rmode,xfb,COLOR_BLACK);
	Reboot();
	return 0;
}
